<?php
defined( 'ABSPATH' ) || exit( 'No Access!' );

switch ( $columns ) {
	default:
	case '1':
		$class1 = 'col-12';
		$class2 = 'col-12';
		$class3 = 'col-12';
		$class4 = 'col-12';
		break;
	case '1-3':
		$class1 = 'col-12 col-md-3';
		$class2 = 'col-12 col-md-9';
		$class3 = 'col-12 col-md-3';
		$class4 = 'col-12 col-md-9';
		break;
	case '2-2':
		$class1 = 'col-12 col-md-6';
		$class2 = 'col-12 col-md-6';
		$class3 = 'col-12 col-md-6';
		$class4 = 'col-12 col-md-6';
		break;
	case '3-1':
		$class1 = 'col-12 col-md-9';
		$class2 = 'col-12 col-md-3';
		$class3 = 'col-12 col-md-9';
		$class4 = 'col-12 col-md-3';
		break;
	case '1-1-1-1':
		$class1 = 'col-6 col-md-3';
		$class2 = 'col-6 col-md-3';
		$class3 = 'col-6 col-md-3';
		$class4 = 'col-6 col-md-3';
		break;
}

$image1 = irk_linked_image( $url1, $image1, $target1, $xfn1 );
$image2 = irk_linked_image( $url2, $image2, $target2, $xfn2 );
$image3 = irk_linked_image( $url3, $image3, $target3, $xfn3 );
$image4 = irk_linked_image( $url4, $image4, $target4, $xfn4 );

echo '<div class="row">';
echo $image1 ? '<div class="' . $class1 . '">' . $image1 . '</div>' : null;
echo $image2 ? '<div class="' . $class2 . '">' . $image2 . '</div>' : null;
echo $image3 ? '<div class="' . $class3 . '">' . $image3 . '</div>' : null;
echo $image4 ? '<div class="' . $class4 . '">' . $image4 . '</div>' : null;
echo '</div>';